/* Alessandro Rubini 2010, public domain */
#include <stdio.h>
#include <stdlib.h>

struct int_item {
	int value;
	struct int_item *next;
};

#define list_insert(h, new) \
	({(new)->next = (h); (h) = (new);})

#define list_extract(h) \
	({struct int_item *res = (h); if (h) (h) = (h)->next; res;})

/* This program reads integers from stdin and prints it reversed */
int main(int argc, char **argv)
{
	struct int_item *head = NULL;
	struct int_item *item;
	char line[16];

	/* read data */
	while (fgets(line, 16, stdin)) {
		item = malloc(sizeof(*item));
		item->value = atoi(line);
		list_insert(head, item);
	}

	/* write it back */
	while ( (item = list_extract(head)) ) {
		printf("%12i\n", item->value);
		free(item);
	}

	return 0;
}
